/*###############################################################################
# Linux Management Providers (LMP), SSH provider package
# Copyright (C) 2010 Feng Zhanlei, REDFLAG <fengzhanlei@redflag-linux.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by Guillaume BOTTEX <guillaumebottex@uxsystem.net>, UXSystem, 2010
###############################################################################*/

#include "cmpiOpenDRIM_SSHProtocolEndpoint.h"

CMPIObjectPath* SSH_OpenDRIM_SSHProtocolEndpoint_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_SSHProtocolEndpoint& instance) {
	_E_;
	Objectpath op(broker, OpenDRIM_SSHProtocolEndpoint_classnames[0], OpenDRIM_SSHProtocolEndpoint_NAMESPACE);

	if (!instance.SystemCreationClassName_isNULL)
		op.addKey("SystemCreationClassName", instance.SystemCreationClassName);

	if (!instance.SystemName_isNULL)
		op.addKey("SystemName", instance.SystemName);

	if (!instance.CreationClassName_isNULL)
		op.addKey("CreationClassName", instance.CreationClassName);

	if (!instance.Name_isNULL)
		op.addKey("Name", instance.Name);

	_L_;
	return op.getHdl();
}

CMPIInstance* SSH_OpenDRIM_SSHProtocolEndpoint_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_SSHProtocolEndpoint& instance) {
	_E_;
	Objectpath op(broker, SSH_OpenDRIM_SSHProtocolEndpoint_toCMPIObjectPath(broker, instance));
	Instance ci(broker, op);

	if (!instance.InstanceID_isNULL)
		ci.setProperty("InstanceID", instance.InstanceID);

	if (!instance.Caption_isNULL)
		ci.setProperty("Caption", instance.Caption);

	if (!instance.ElementName_isNULL)
		ci.setProperty("ElementName", instance.ElementName);

	if (!instance.Generation_isNULL)
		ci.setProperty("Generation", instance.Generation);

	if (!instance.InstallDate_isNULL)
		ci.setPropertyDatetime("InstallDate", instance.InstallDate);

	if (!instance.StatusDescriptions_isNULL)
		ci.setProperty("StatusDescriptions", instance.StatusDescriptions);

	if (!instance.Status_isNULL)
		ci.setProperty("Status", instance.Status);

	if (!instance.HealthState_isNULL)
		ci.setProperty("HealthState", instance.HealthState);

	if (!instance.CommunicationStatus_isNULL)
		ci.setProperty("CommunicationStatus", instance.CommunicationStatus);

	if (!instance.DetailedStatus_isNULL)
		ci.setProperty("DetailedStatus", instance.DetailedStatus);

	if (!instance.OperatingStatus_isNULL)
		ci.setProperty("OperatingStatus", instance.OperatingStatus);

	if (!instance.PrimaryStatus_isNULL)
		ci.setProperty("PrimaryStatus", instance.PrimaryStatus);

	if (!instance.OtherEnabledState_isNULL)
		ci.setProperty("OtherEnabledState", instance.OtherEnabledState);

	if (!instance.RequestedState_isNULL)
		ci.setProperty("RequestedState", instance.RequestedState);

	if (!instance.EnabledDefault_isNULL)
		ci.setProperty("EnabledDefault", instance.EnabledDefault);

	if (!instance.AvailableRequestedStates_isNULL)
		ci.setProperty("AvailableRequestedStates", instance.AvailableRequestedStates);

	if (!instance.TransitioningToState_isNULL)
		ci.setProperty("TransitioningToState", instance.TransitioningToState);

	if (!instance.Description_isNULL)
		ci.setProperty("Description", instance.Description);

	if (!instance.OperationalStatus_isNULL)
		ci.setProperty("OperationalStatus", instance.OperationalStatus);

	if (!instance.EnabledState_isNULL)
		ci.setProperty("EnabledState", instance.EnabledState);

	if (!instance.TimeOfLastStateChange_isNULL)
		ci.setPropertyDatetime("TimeOfLastStateChange", instance.TimeOfLastStateChange);

	if (!instance.NameFormat_isNULL)
		ci.setProperty("NameFormat", instance.NameFormat);

	if (!instance.ProtocolType_isNULL)
		ci.setProperty("ProtocolType", instance.ProtocolType);

	if (!instance.ProtocolIFType_isNULL)
		ci.setProperty("ProtocolIFType", instance.ProtocolIFType);

	if (!instance.OtherTypeDescription_isNULL)
		ci.setProperty("OtherTypeDescription", instance.OtherTypeDescription);

	if (!instance.BroadcastResetSupported_isNULL)
		ci.setProperty("BroadcastResetSupported", instance.BroadcastResetSupported);

	if (!instance.EnabledSSHVersions_isNULL)
		ci.setProperty("EnabledSSHVersions", instance.EnabledSSHVersions);

	if (!instance.OtherEnabledSSHVersion_isNULL)
		ci.setProperty("OtherEnabledSSHVersion", instance.OtherEnabledSSHVersion);

	if (!instance.SSHVersion_isNULL)
		ci.setProperty("SSHVersion", instance.SSHVersion);

	if (!instance.OtherSSHVersion_isNULL)
		ci.setProperty("OtherSSHVersion", instance.OtherSSHVersion);

	if (!instance.EnabledEncryptionAlgorithms_isNULL)
		ci.setProperty("EnabledEncryptionAlgorithms", instance.EnabledEncryptionAlgorithms);

	if (!instance.OtherEnabledEncryptionAlgorithm_isNULL)
		ci.setProperty("OtherEnabledEncryptionAlgorithm", instance.OtherEnabledEncryptionAlgorithm);

	if (!instance.EncryptionAlgorithm_isNULL)
		ci.setProperty("EncryptionAlgorithm", instance.EncryptionAlgorithm);

	if (!instance.OtherEncryptionAlgorithm_isNULL)
		ci.setProperty("OtherEncryptionAlgorithm", instance.OtherEncryptionAlgorithm);

	if (!instance.IdleTimeout_isNULL)
		ci.setProperty("IdleTimeout", instance.IdleTimeout);

	if (!instance.KeepAlive_isNULL)
		ci.setProperty("KeepAlive", instance.KeepAlive);

	if (!instance.ForwardX11_isNULL)
		ci.setProperty("ForwardX11", instance.ForwardX11);

	if (!instance.Compression_isNULL)
		ci.setProperty("Compression", instance.Compression);

	_L_;
	return ci.getHdl();
}

void SSH_OpenDRIM_SSHProtocolEndpoint_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_SSHProtocolEndpoint& instance) {
	_E_;
	Objectpath op(broker, (CMPIObjectPath*) ref);

	if (op.getKey("SystemCreationClassName", instance.SystemCreationClassName) == OK)
		instance.SystemCreationClassName_isNULL = false;

	if (op.getKey("Name", instance.Name) == OK)
		instance.Name_isNULL = false;

	if (op.getKey("SystemName", instance.SystemName) == OK)
		instance.SystemName_isNULL = false;

	if (op.getKey("CreationClassName", instance.CreationClassName) == OK)
		instance.CreationClassName_isNULL = false;

	_L_;
}

void SSH_OpenDRIM_SSHProtocolEndpoint_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_SSHProtocolEndpoint& instance) {
	_E_;
	Instance inst(broker, (CMPIInstance*) ci);

	if (inst.getProperty("InstanceID", instance.InstanceID) == OK)
		instance.InstanceID_isNULL = false;

	if (inst.getProperty("Caption", instance.Caption) == OK)
		instance.Caption_isNULL = false;

	if (inst.getProperty("ElementName", instance.ElementName) == OK)
		instance.ElementName_isNULL = false;

	if (inst.getProperty("Generation", instance.Generation) == OK)
		instance.Generation_isNULL = false;

	if (inst.getPropertyDatetime("InstallDate", instance.InstallDate) == OK)
		instance.InstallDate_isNULL = false;

	if (inst.getProperty("StatusDescriptions", instance.StatusDescriptions) == OK)
		instance.StatusDescriptions_isNULL = false;

	if (inst.getProperty("Status", instance.Status) == OK)
		instance.Status_isNULL = false;

	if (inst.getProperty("HealthState", instance.HealthState) == OK)
		instance.HealthState_isNULL = false;

	if (inst.getProperty("CommunicationStatus", instance.CommunicationStatus) == OK)
		instance.CommunicationStatus_isNULL = false;

	if (inst.getProperty("DetailedStatus", instance.DetailedStatus) == OK)
		instance.DetailedStatus_isNULL = false;

	if (inst.getProperty("OperatingStatus", instance.OperatingStatus) == OK)
		instance.OperatingStatus_isNULL = false;

	if (inst.getProperty("PrimaryStatus", instance.PrimaryStatus) == OK)
		instance.PrimaryStatus_isNULL = false;

	if (inst.getProperty("OtherEnabledState", instance.OtherEnabledState) == OK)
		instance.OtherEnabledState_isNULL = false;

	if (inst.getProperty("RequestedState", instance.RequestedState) == OK)
		instance.RequestedState_isNULL = false;

	if (inst.getProperty("EnabledDefault", instance.EnabledDefault) == OK)
		instance.EnabledDefault_isNULL = false;

	if (inst.getProperty("AvailableRequestedStates", instance.AvailableRequestedStates) == OK)
		instance.AvailableRequestedStates_isNULL = false;

	if (inst.getProperty("TransitioningToState", instance.TransitioningToState) == OK)
		instance.TransitioningToState_isNULL = false;

	if (inst.getProperty("SystemCreationClassName", instance.SystemCreationClassName) == OK)
		instance.SystemCreationClassName_isNULL = false;

	if (inst.getProperty("SystemName", instance.SystemName) == OK)
		instance.SystemName_isNULL = false;

	if (inst.getProperty("CreationClassName", instance.CreationClassName) == OK)
		instance.CreationClassName_isNULL = false;

	if (inst.getProperty("Name", instance.Name) == OK)
		instance.Name_isNULL = false;

	if (inst.getProperty("Description", instance.Description) == OK)
		instance.Description_isNULL = false;

	if (inst.getProperty("OperationalStatus", instance.OperationalStatus) == OK)
		instance.OperationalStatus_isNULL = false;

	if (inst.getProperty("EnabledState", instance.EnabledState) == OK)
		instance.EnabledState_isNULL = false;

	if (inst.getPropertyDatetime("TimeOfLastStateChange", instance.TimeOfLastStateChange) == OK)
		instance.TimeOfLastStateChange_isNULL = false;

	if (inst.getProperty("NameFormat", instance.NameFormat) == OK)
		instance.NameFormat_isNULL = false;

	if (inst.getProperty("ProtocolType", instance.ProtocolType) == OK)
		instance.ProtocolType_isNULL = false;

	if (inst.getProperty("ProtocolIFType", instance.ProtocolIFType) == OK)
		instance.ProtocolIFType_isNULL = false;

	if (inst.getProperty("OtherTypeDescription", instance.OtherTypeDescription) == OK)
		instance.OtherTypeDescription_isNULL = false;

	if (inst.getProperty("BroadcastResetSupported", instance.BroadcastResetSupported) == OK)
		instance.BroadcastResetSupported_isNULL = false;

	if (inst.getProperty("EnabledSSHVersions", instance.EnabledSSHVersions) == OK)
		instance.EnabledSSHVersions_isNULL = false;

	if (inst.getProperty("OtherEnabledSSHVersion", instance.OtherEnabledSSHVersion) == OK)
		instance.OtherEnabledSSHVersion_isNULL = false;

	if (inst.getProperty("SSHVersion", instance.SSHVersion) == OK)
		instance.SSHVersion_isNULL = false;

	if (inst.getProperty("OtherSSHVersion", instance.OtherSSHVersion) == OK)
		instance.OtherSSHVersion_isNULL = false;

	if (inst.getProperty("EnabledEncryptionAlgorithms", instance.EnabledEncryptionAlgorithms) == OK)
		instance.EnabledEncryptionAlgorithms_isNULL = false;

	if (inst.getProperty("OtherEnabledEncryptionAlgorithm", instance.OtherEnabledEncryptionAlgorithm) == OK)
		instance.OtherEnabledEncryptionAlgorithm_isNULL = false;

	if (inst.getProperty("EncryptionAlgorithm", instance.EncryptionAlgorithm) == OK)
		instance.EncryptionAlgorithm_isNULL = false;

	if (inst.getProperty("OtherEncryptionAlgorithm", instance.OtherEncryptionAlgorithm) == OK)
		instance.OtherEncryptionAlgorithm_isNULL = false;

	if (inst.getProperty("IdleTimeout", instance.IdleTimeout) == OK)
		instance.IdleTimeout_isNULL = false;

	if (inst.getProperty("KeepAlive", instance.KeepAlive) == OK)
		instance.KeepAlive_isNULL = false;

	if (inst.getProperty("ForwardX11", instance.ForwardX11) == OK)
		instance.ForwardX11_isNULL = false;

	if (inst.getProperty("Compression", instance.Compression) == OK)
		instance.Compression_isNULL = false;

	_L_;
}

void SSH_OpenDRIM_SSHProtocolEndpoint_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_SSHProtocolEndpoint_RequestStateChange_In& args) {
	_E_;
	CMPIStatus rc;
	CMPIData data;

	unsigned short RequestedState;
	data = in->ft->getArg(in, "RequestedState", &rc);
	if (rc.rc == OK) {
		CT_ToC(data, RequestedState);	
		args.setRequestedState(RequestedState);
	}			

	Objectpath Job;
	data = in->ft->getArg(in, "Job", &rc);
	if (rc.rc == OK) {
		CT_ToC(broker, data, Job);	
		args.setJob(Job);
	}			

	string TimeoutPeriod;
	data = in->ft->getArg(in, "TimeoutPeriod", &rc);
	if (rc.rc == OK) {
		CT_ToCDatetime(data, TimeoutPeriod);	
		args.setTimeoutPeriod(TimeoutPeriod);
	}			

	_L_;
}

void SSH_OpenDRIM_SSHProtocolEndpoint_toCMPIArg(const CMPIBroker* broker, CMPIArgs* out, const OpenDRIM_SSHProtocolEndpoint_RequestStateChange_Out& args) {
	_E_;
	CMPIValue value;
	int errorMessage;

	Objectpath Job;
	errorMessage = args.getJob(Job);
	if (errorMessage == OK) {
		value = CT_toCMPI(Job);
		out->ft->addArg(out, "Job", &value, CMPI_ref);
	}

	_L_;
}
